VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} configuration 
   Caption         =   "Configuration"
   ClientHeight    =   5625
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   6750
   OleObjectBlob   =   "configuration.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "configuration"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False






Option Explicit

Private Sub FFTOrgASMList_Click()
    With configuration
        Select Case .FFTOrgASMList.ListIndex
            Case 0
                .FFTOrgASMFocus.Enabled = False
            Case 1
                .FFTOrgASMFocus.Enabled = True
            Case 2
                .FFTOrgASMFocus.Enabled = True
            Case 3
                .FFTOrgASMFocus.Enabled = False
        End Select
    End With
End Sub

Private Sub FocuspSX_Click()
    With configuration
        .RestoreDebugger.Enabled = .FocuspSX.Value
        .QuicksaveList.Enabled = .FocuspSX.Value
    End With
End Sub

Private Sub ISOButton_Click()
    Dim FilePath As String
    Dim FolderFromPath As String
    FilePath = ReadReg(RegFolder & "Last ISO", "")
    If Len(FilePath) < 5 Then FilePath = ActiveWorkbook.path & "\a"
    FolderFromPath = Left(FilePath, InStrRev(FilePath, "\"))
    If Len(Dir(FolderFromPath)) Then ChDir FolderFromPath
    FilePath = Application.GetOpenFilename(FileFilter:="M2/2352 PSX Image (*.bin;*.img;*.iso), *.bin;*.img;*.iso", Title:="Select a PSX Image", MultiSelect:=False)
    If FilePath = "False" Then
        Exit Sub
    End If
    configuration.ISOString.Value = FilePath
End Sub

Private Sub OKButton_Click()
    SaveConfiguration
End Sub

Private Sub CancelButton_Click()
    Unload Me
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub configuration_KeyPress(ByVal KeyAscii As MsForms.ReturnInteger)
    If KeyAscii = vbKeyEnter Then
        SaveConfiguration
    End If
    ElseIf KeyAscii = vbKeyEscape Then
        Unload Me
    End If
End Sub

Public Sub SaveConfiguration()
    Dim Indent_Value As Integer
    With configuration
        WriteReg RegFolder & "Last Quicksave", .QuicksaveString.Value, REG_SZ
        WriteReg RegFolder & "Debug Quicksave", .DebugQuicksave.Value, REG_DWORD
        WriteReg RegFolder & "pSX Focus", .FocuspSX.Value, REG_DWORD
        WriteReg RegFolder & "Quicksave ID", .QuicksaveList.ListIndex, REG_DWORD
        WriteReg RegFolder & "Don't Trim XML", .NoTrimXML.Value, REG_DWORD
        WriteReg RegFolder & "After XML Export", .FFTOrgASMList.ListIndex, REG_DWORD
        WriteReg RegFolder & "FFTOrgASM Focus", .FFTOrgASMFocus.Value, REG_DWORD
        WriteReg RegFolder & "Restore Debugger", .RestoreDebugger.Value, REG_DWORD
        WriteReg RegFolder & "Text Ripping Method", .FFTTextList.ListIndex, REG_DWORD
        WriteReg RegFolder & "Blank String Format", BSBox.Text, REG_SZ
        WriteReg RegFolder & "Single String Format", SSBox.Text, REG_SZ
        WriteReg RegFolder & "Duplicate String Format", DSBox.Text, REG_SZ
        WriteReg RegFolder & "Empty Blank", EmptyBlank.Value, REG_DWORD
        WriteReg RegFolder & "Last ISO", ISOString.Text, REG_SZ
        WriteReg RegFolder & "Auto Select Last ISO", .AutoloadISO.Value, REG_DWORD
        WriteReg RegFolder & "Hide Long Strings", .HideCodeTags.Value, REG_DWORD
        If .Indent0.Value Then
            Indent_Value = 0
        ElseIf .Indent1.Value Then
            Indent_Value = 1
        ElseIf .Indent2.Value Then
            Indent_Value = 2
        End If
        If .SSD0.Value Then
            WriteReg RegFolder & "SSD", 0, REG_DWORD
        Else
            WriteReg RegFolder & "SSD", 1, REG_DWORD
        End If
        WriteReg RegFolder & "XML Indent", CStr(Indent_Value), REG_DWORD
        WriteReg RegFolder & "crlf -> XMLcrlf", .XMLcrlf.Value, REG_DWORD
    End With
    Unload Me
End Sub

Private Sub QuicksaveButton_Click()
    Dim FilePath As String
    Dim FolderFromPath As String
    FilePath = ReadReg(RegFolder & "Last Quicksave", "")
    If Len(FilePath) < 5 Then FilePath = ActiveWorkbook.path & "\a"
    FolderFromPath = Left(FilePath, InStrRev(FilePath, "\"))
    If Len(Dir(FolderFromPath)) Then ChDir FolderFromPath
    FilePath = Application.GetOpenFilename(FileFilter:="pSX Quicksave (*.psv), *.psv", Title:="Select a pSX Quicksave File", MultiSelect:=False)
    If FilePath = "False" Then
        Exit Sub
    End If
    configuration.QuicksaveString.Value = FilePath
End Sub

Private Sub DuplicateString_Change()
End Sub

Private Sub BSBox_Change()
    BSLabel.Caption = "Ex: """ & Replace(Replace(BSBox.Text, "$", "Cure"), "#", "001") & """"
End Sub

Private Sub SSBox_Change()
    SSLabel.Caption = "Ex: """ & Replace(Replace(SSBox.Text, "$", "Cure"), "#", "001") & """"
End Sub

Private Sub DSBox_Change()
    DSLabel.Caption = "Ex: """ & Replace(Replace(DSBox.Text, "$", "Cure"), "#", "001") & """"
End Sub

Private Sub UserForm_Initialize()
    With Me
        With .QuicksaveList
            .Clear
            .AddItem "Do nothing"
            .AddItem "Autodetect and load Quicksave (F1 to F5)"
            .AddItem "Load Quicksave #1 (F1)"
            .AddItem "Load Quicksave #2 (F2)"
            .AddItem "Load Quicksave #3 (F3)"
            .AddItem "Load Quicksave #4 (F4)"
            .AddItem "Load Quicksave #5 (F5)"
        End With
        With .FFTOrgASMList
            .Clear
            .AddItem "Do nothing"
            .AddItem "Prompt to open FFTOrgASM (yes/no)"
            .AddItem "Open FFTOrgASM"
            .AddItem "Change window focus to FFTOrgASM"
        End With
        With .FFTTextList
            .Clear
            .AddItem "Open ""FFTText Editor.xlsm"" if present in the same folder"
            .AddItem "Prompt to open ""FFTText Editor.xlsm"" if not found in the same folder"
            .AddItem "Always Prompt to open ""FFTText Editor.xlsm"""
        End With
        .QuicksaveString.Value = ReadReg(RegFolder & "Last Quicksave", "")
        .DebugQuicksave.Value = ReadReg(RegFolder & "Debug Quicksave", 0)
        .FocuspSX = ReadReg(RegFolder & "pSX Focus", 1)
        .QuicksaveList.ListIndex = ReadReg(RegFolder & "Quicksave ID", 1, QuickIDMax)
        .NoTrimXML.Value = ReadReg(RegFolder & "Don't Trim XML", 0)
        .FFTOrgASMList.ListIndex = ReadReg(RegFolder & "After XML Export", 1, XMLExpMax)
        .FFTOrgASMFocus.Value = ReadReg(RegFolder & "FFTOrgASM Focus", 0)
        .RestoreDebugger.Value = ReadReg(RegFolder & "Restore Debugger", 0)
        .FFTTextList.ListIndex = ReadReg(RegFolder & "Text Ripping Method", 1, TextRipMax)
        .BSBox.Text = ReadReg(RegFolder & "Blank String Format", BSFormat)
        .SSBox.Text = ReadReg(RegFolder & "Single String Format", SSFormat)
        .DSBox.Text = ReadReg(RegFolder & "Duplicate String Format", DSFormat)
        .BSLabel.Caption = "Ex: """ & Replace(Replace(.BSBox.Text, "$", "Cure"), "#", "001") & """"
        .SSLabel.Caption = "Ex: """ & Replace(Replace(.SSBox.Text, "$", "Cure"), "#", "001") & """"
        .DSLabel.Caption = "Ex: """ & Replace(Replace(.DSBox.Text, "$", "Cure"), "#", "001") & """"
        .EmptyBlank.Value = ReadReg(RegFolder & "Empty Blank", 1)
        .OKButton.SetFocus
        .RestoreDebugger.Enabled = .FocuspSX.Value
        .QuicksaveList.Enabled = .FocuspSX.Value
        If ReadReg(RegFolder & "SSD", 0) = 0 Then
            .SSD0.Value = True
        Else
            .SSD1.Value = True
        End If
        Select Case .FFTOrgASMList.ListIndex
            Case 0: .FFTOrgASMFocus.Enabled = False
            Case 1: .FFTOrgASMFocus.Enabled = True
            Case 2: .FFTOrgASMFocus.Enabled = True
            Case 3: .FFTOrgASMFocus.Enabled = False
        End Select
        .ISOString.Value = ReadReg(RegFolder & "Last ISO", "")
        .AutoloadISO.Value = ReadReg(RegFolder & "Auto Select Last ISO", 0)
        .HideCodeTags.Value = ReadReg(RegFolder & "Hide Long Strings", 1)
        .XMLcrlf.Value = ReadReg(RegFolder & "crlf -> XMLcrlf", 1)
        .VersionLabel.Caption = "v" & SharedXifiSheets_Version & " By Xifanie"

        Select Case ReadReg(RegFolder & "XML Indent", 1, 2)
            Case 0: .Indent0.Value = True
            Case 1: .Indent1.Value = True
            Case 2: .Indent2.Value = True
        End Select
    End With
End Sub
