VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} importcodeform 
   Caption         =   "Import Code"
   ClientHeight    =   3600
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   3480
   OleObjectBlob   =   "importcodeform.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "importcodeform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False







Option Explicit

Private Sub Toggle_File()
    If ISO.Value Then
        Filename.Enabled = True
        Filename.BackColor = &H80000005
    Else
        Filename.Enabled = False
        Filename.BackColor = &H8000000B
    End If
    If Clipboard.Value Then
        Start_Offset.Enabled = False
        Start_Offset.BackColor = &H8000000B
        End_Offset.Enabled = False
        End_Offset.BackColor = &H8000000B
    Else
        Start_Offset.Enabled = True
        Start_Offset.BackColor = &H80000005
        End_Offset.Enabled = True
        End_Offset.BackColor = &H80000005
    End If
End Sub

Private Sub ISO_Click()
    Call Toggle_File
End Sub
Private Sub Savestate_Click()
    Call Toggle_File
End Sub
Private Sub Clipboard_Click()
    Call Toggle_File
End Sub

Private Sub Create_Code(Append As Boolean)
    If Not Import_Files_List Then Exit Sub
    Dim S_Offset As Long, E_Offset As Long
    Dim Match_ID As Long
    Dim Mode As Fetch_Mode
    Match_ID = -1
    
    If Clipboard.Value Then
        Dim DataObj As MsForms.DataObject
        Set DataObj = New MsForms.DataObject
        
        On Error GoTo Clipboard_Error
        DataObj.GetFromClipboard
        On Error GoTo 0
        
        Dim Clipboard_Data As String
        Dim Clipboard_Lines() As String
        Dim Hex_Address As String, Hex_Opcode As String
        Dim a As Long
        Dim Old_Address As Long, New_Address As Long
        Dim Hack_List As Hack_List
        ReDim Hack_List.Hacks(0 To 0)
        ReDim Hack_List.Patch_Objects(0 To 255)
        ReDim Hack_List.Locations(0 To 65535)
        Dim Entry_Count As Long, Location_Count As Long, Comment_Start As Long
        Entry_Count = -1
        Location_Count = -1
        
        Clipboard_Data = Replace(DataObj.GetText(1), vbCr, "")
        Clipboard_Lines = Split(Clipboard_Data, vbLf)
        Old_Address = -2147483647
        For a = LBound(Clipboard_Lines) To UBound(Clipboard_Lines)
            If Len(Clipboard_Lines(a)) >= 18 Then
                Hex_Address = Left(Clipboard_Lines(a), 8)
                If IsHex(Hex_Address) Then
                    New_Address = "&H" & Hex_Address
                    If New_Address <> Old_Address + 4 Then
                        Entry_Count = Entry_Count + 1
                        Location_Count = Location_Count + 1
                        Hack_List.Patch_Objects(Entry_Count).Start_Location = Location_Count
                        Hack_List.Patch_Objects(Entry_Count).Offset = New_Address
                        Hack_List.Patch_Objects(Entry_Count).Memory = True
                        Hack_List.Patch_Objects(Entry_Count).Type = 1
                        Hack_List.Patch_Objects(Entry_Count).File_ID = -1
                        Hack_List.Patch_Objects(Entry_Count).Sector = -1
                    End If
                    Old_Address = New_Address
                    Hex_Opcode = ReverseBytes(Mid(Clipboard_Lines(a), 11, 8), 4)
                    If IsHex(Hex_Opcode) Then
                        Hack_List.Locations(Location_Count).Raw_String = Hex_Opcode
                        Hack_List.Locations(Location_Count).Offset = New_Address
                        Hack_List.Patch_Objects(Entry_Count).End_Location = Location_Count + 1
                        Comment_Start = InStr(18, Clipboard_Lines(a), "    ")
                        If Comment_Start = 0 Then Comment_Start = InStr(18, Clipboard_Lines(a), vbTab)
                        If Comment_Start > 0 Then
                            Hack_List.Locations(Location_Count).Comment = Smart_Trim(Mid(Clipboard_Lines(a), Comment_Start))
                        End If
                        Location_Count = Location_Count + 1
                    End If
                End If
            End If
        Next
        Location_Count = Location_Count + 1
        Hack_List.Hacks(0).First = 0
        Hack_List.Hacks(0).Last = Entry_Count
        Hack_List.Hacks(0).Name = "Patch generated on: " & Format(Now(), "yyyy/mm/dd hh:mm:ss")
        Hack_List.Hacks(0).Description = "Ripped from clipboard"
        
        On Error GoTo Clipboard_Error
        ReDim Preserve Hack_List.Patch_Objects(0 To Entry_Count)
        ReDim Preserve Hack_List.Locations(0 To Location_Count - 1)
        Insert_Hacks Hack_List, Append
        Exit Sub
Clipboard_Error:
        If Err <> 0 Then MsgBox "Data on clipboard is not text, is empty, or is not the right format."
    Else
        S_Offset = HexDecToDec(Start_Offset.Value)
        E_Offset = HexDecToDec(End_Offset.Value)
        If S_Offset < 0 Then MsgBox "Invalid Start Offset value", vbCritical, "Import Data": Exit Sub
        If E_Offset < 0 Then MsgBox "Invalid End Offset value", vbCritical, "Import Data": Exit Sub
        If ISO.Value Then
            Match_ID = GetFileMatch(Filename.Value, True, True, True)
            If Match_ID < 0 Then MsgBox "Invalid File """ & Filename.Value & """.", vbCritical, "Import Data": Exit Sub
        End If
        If Savestate.Value Then
            Mode = Import_From_Savestate
        Else
            Mode = Import_From_ISO
        End If
        VBATime True
        Fetch_Code Mode, S_Offset, E_Offset, Append, Match_ID, True
        VBATime False
    End If
End Sub

Private Sub Create_Patch_Click()
    Create_Code True
End Sub

Private Sub Insert_Click()
    Create_Code False
End Sub

Private Sub UserForm_Initialize()
    Me.StartUpPosition = 0
    Me.Left = CLng(ReadReg(RegFolder & "Import\Code\Window_X", CStr(Application.Left + Int((Application.width - Me.width) / 2)), 2147483647))
    Me.Top = CLng(ReadReg(RegFolder & "Import\Code\Window_Y", CStr(Application.Top + Int((Application.Height - Me.Height) / 2)), 2147483647))
    Dim File_Type As Byte
    File_Type = ReadReg(RegFolder & "Import\Type", 1, 2)
    Select Case File_Type
        Case 0: Savestate.Value = True
        Case 1: ISO.Value = True
        Case 2: Clipboard.Value = True
    End Select
    Call Toggle_File
    Filename.Value = ReadReg(RegFolder & "Import\Code\Filename", "")
    Start_Offset.Value = ReadReg(RegFolder & "Import\Code\Start_Offset", "0x80000000")
    End_Offset.Value = ReadReg(RegFolder & "Import\Code\End_Offset", "0x80000000")
    Memory.Value = True
    'Memory.Value = ReadReg(RegFolder & "Import\Code\Memory", "1", 1)
End Sub
Private Sub UserForm_QueryClose(Cancel As Integer, CloseMode As Integer)
    Call WriteReg(RegFolder & "Import\Code\Window_X", Me.Left - Application.Left)
    Call WriteReg(RegFolder & "Import\Code\Window_Y", Me.Top - Application.Top)
    Dim File_Type As Byte
    If Savestate.Value Then
        Call WriteReg(RegFolder & "Import\Type", 0)
    ElseIf Clipboard.Value Then
        Call WriteReg(RegFolder & "Import\Type", 2)
    Else
        Call WriteReg(RegFolder & "Import\Type", 1)
    End If
    Call WriteReg(RegFolder & "Import\Code\Filename", Filename.Value)
    Call WriteReg(RegFolder & "Import\Code\Start_Offset", Start_Offset.Value)
    Call WriteReg(RegFolder & "Import\Code\End_Offset", End_Offset.Value)
    'Call WriteReg(RegFolder & "Import\Code\Memory", Memory.Value)
End Sub

