VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} importdataform 
   Caption         =   "Import Data"
   ClientHeight    =   4920
   ClientLeft      =   930
   ClientTop       =   375
   ClientWidth     =   3480
   OleObjectBlob   =   "importdataform.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "importdataform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False






Option Explicit

Private Sub Toggle_File()
    If Savestate.Value Then
        Filename.Enabled = False
        Filename.BackColor = &H8000000B
    Else
        Filename.Enabled = True
        Filename.BackColor = &H80000005
    End If
End Sub
Private Sub ISO_Click()
    Call Toggle_File
End Sub
Private Sub Savestate_Click()
    Call Toggle_File
End Sub

Private Sub Format_Help_Click()
    MsgBox "Legend:" & vbCrLf & _
    "i = ignore (the entry will not be assigned a column)" & vbCrLf & _
    "h = hexadecimal (automatically flips bytes, default)" & vbCrLf & _
    "s = decimal signed" & vbCrLf & _
    "u = decimal unsigned" & vbCrLf & _
    "b = binary" & vbCrLf & _
    "B = binary (separate columns)" & vbCrLf & _
    "a = array of bytes" & vbCrLf & _
    vbCrLf & _
    "- Each column/entry must be separated by a ""/"";" & vbCrLf & _
    "- The sum of all numbers must add up to ""# Bytes per Row"";" & vbCrLf & _
    "- An empty string will return 1 byte (hex) per column." & vbCrLf & _
    vbCrLf & _
    "For example, the format ""1b/1i/4a/2u/2s/2h""" & vbCrLf & _
    "with row ""84 00 64 40 20 80 FF FF FE FF FE 01""," & vbCrLf & _
    "would return ""[10000100][64402080][65535][-2][01FE]""."
End Sub

Private Sub Update_Num_Rows()
    On Error GoTo Sub_End
    If ActiveControl.Name = End_Offset.Name Then
        On Error GoTo Default
        Dim New_Num_Rows As Long
        Dim S_Offset As Long
        Dim Row_Bytes As Long
        Row_Bytes = HexDecToDec(Bytes_Per_Row.Value)
        If Row_Bytes > 0 Then
            S_Offset = HexDecToDec(Start_Offset.Value)
            New_Num_Rows = Int((HexDecToDec(End_Offset.Value) + 1 - S_Offset) / HexDecToDec(Bytes_Per_Row.Value))
            Num_Rows.Value = New_Num_Rows
        End If
        Exit Sub
Default:
        Num_Rows.Value = 0
    End If
Sub_End:
End Sub

Private Sub Update_End_Offset()
    On Error GoTo Sub_End
    If ActiveControl.Name <> End_Offset.Name Then
        On Error GoTo Default
        Dim New_End_Offset As Long
        New_End_Offset = HexDecToDec(Start_Offset.Value) + HexDecToDec(Bytes_Per_Row.Value) * HexDecToDec(Num_Rows.Value) - 1
        If Left(Start_Offset.Value, 2) = "0x" Then
            Select Case Mid(Start_Offset.Value, 3, 1)
                Case "8"
                    End_Offset.Value = "0x8" & DecToHex(New_End_Offset, 7)
                Case Else
                    End_Offset.Value = "0x0" & DecToHex(New_End_Offset, 7)
            End Select
        Else
            End_Offset.Value = New_End_Offset
        End If
        Exit Sub
Default:
        End_Offset.Value = 0
    End If
Sub_End:
End Sub
Private Sub Num_Rows_Change()
    Call Update_End_Offset
End Sub

Private Sub Toggle_Split()
    If Split_Into_Columns.Value = True Then
        Format.Enabled = True
        Format.BackColor = &H80000005
    Else
        Format.Enabled = False
        Format.BackColor = &H8000000B
    End If
End Sub
Private Sub Split_Into_Columns_Click()
    Call Toggle_Split
End Sub

Private Sub Start_Offset_Change()
    Call Update_End_Offset
End Sub
Private Sub Bytes_Per_Row_Change()
    Call Update_End_Offset
End Sub
Private Sub End_Offset_Change()
    Call Update_Num_Rows
End Sub

Private Sub Preview_Click()
    Dim Format_Results As Format_Results
    Format_Results = Table_Format(Format.Value, HexDecToDec(Bytes_Per_Row.Value), Split_Into_Columns.Value)
    Range(Cells(Selection.Row, Selection.Column), Cells(Selection.Row + HexDecToDec(Num_Rows.Value, 1) - 1, Selection.Column + Format_Results.Column_Count - 1)).Select
End Sub

Private Sub Print_Data_Click()
    Dim S_Offset As Long, E_Offset As Long, Byte_Length As Long, Row_Count As Long
    S_Offset = HexDecToDec(Start_Offset.Value)
    E_Offset = HexDecToDec(End_Offset.Value)
    Byte_Length = HexDecToDec(Bytes_Per_Row.Value)
    Row_Count = HexDecToDec(Num_Rows.Value)
    If S_Offset < 0 Then MsgBox "Invalid Start Offset value", vbCritical, "Import Data": Exit Sub
    If E_Offset < 0 Then MsgBox "Invalid End Offset value", vbCritical, "Import Data": Exit Sub
    If Byte_Length < 1 Then MsgBox "Invalid # Bytes per Row value" & vbCrLf & "Must be at least 1.", vbCritical, "Import Data": Exit Sub
    If Row_Count < 1 Then MsgBox "Invalid # Rows value" & vbCrLf & "Must be at least 1.", vbCritical, "Import Data": Exit Sub
    Dim Format_Results As Format_Results
    Format_Results = Table_Format(Format.Value, HexDecToDec(Bytes_Per_Row.Value), Split_Into_Columns.Value)
    If Format_Results.Byte_Count <> Byte_Length Then MsgBox "Your Format entry lists " & Format_Results.Byte_Count & " while yout # Bytes per Row is " & Byte_Length & ".", vbCritical, "Import Data": Exit Sub
    
    Dim fnum As Integer
    fnum = FreeFile
    If Savestate.Value Then
        Open ReadReg(RegFolder & "Last Quicksave", "") For Binary As #fnum
        VBATime True
        Fetch_Data_With_Table Selection, Import_From_Savestate, S_Offset, Row_Count, Format_Results
    Else
        If Not Import_Files_List Then Exit Sub
        Dim Match_ID As Long
        Dim New_Offset As Long
        Match_ID = GetFileMatch(Filename.Value, True, True, True)
        If Match_ID < 0 Then MsgBox "Invalid File """ & Filename.Value & """.", vbCritical, "Import Data": Exit Sub
        If Open_ISO = -1 Then Exit Sub
        VBATime True
        Fetch_Data_With_Table Selection, Import_From_ISO, S_Offset, Row_Count, Format_Results, Match_ID, Memory.Value
    End If
    Call Preview_Click
    Close #fnum
    VBATime False
End Sub

Private Sub UserForm_Initialize()
    Me.StartUpPosition = 0
    Me.Left = CLng(ReadReg(RegFolder & "Import\Data\Window_X", CStr(Application.Left + Int((Application.width - Me.width) / 2)), 2147483647))
    Me.Top = CLng(ReadReg(RegFolder & "Import\Data\Window_Y", CStr(Application.Top + Int((Application.Height - Me.Height) / 2)), 2147483647))
    Dim File_Type As Byte
    File_Type = ReadReg(RegFolder & "Import\ISO", 1, 1)
    Select Case File_Type
        Case 0: Savestate.Value = True
        Case 1: ISO.Value = True
    End Select
    Call Toggle_File
    Filename.Value = ReadReg(RegFolder & "Import\Data\Filename", "")
    Start_Offset.Value = ReadReg(RegFolder & "Import\Data\Start_Offset", "0x80000000")
    End_Offset.Value = ReadReg(RegFolder & "Import\Data\End_Offset", "0x80000000")
    Memory.Value = ReadReg(RegFolder & "Import\Data\Memory", "1", 1)
    Bytes_Per_Row.Value = ReadReg(RegFolder & "Import\Data\Bytes_Per_Row", "0", 2147483647)
    Num_Rows.Value = ReadReg(RegFolder & "Import\Data\Num_Rows", "0", 2147483647)
    Split_Into_Columns.Value = ReadReg(RegFolder & "Import\Data\Split_Into_Columns", 1)
    Format.Value = ReadReg(RegFolder & "Import\Data\Format", "")
    Call Toggle_Split
End Sub
Private Sub UserForm_QueryClose(Cancel As Integer, CloseMode As Integer)
    Call WriteReg(RegFolder & "Import\Data\Window_X", Me.Left - Application.Left)
    Call WriteReg(RegFolder & "Import\Data\Window_Y", Me.Top - Application.Top)
    Dim File_Type As Byte
    If Savestate.Value Then
        Call WriteReg(RegFolder & "Import\ISO", 0)
    Else
        Call WriteReg(RegFolder & "Import\ISO", 1)
    End If
    Call WriteReg(RegFolder & "Import\Data\Filename", Filename.Value)
    Call WriteReg(RegFolder & "Import\Data\Start_Offset", Start_Offset.Value)
    Call WriteReg(RegFolder & "Import\Data\End_Offset", End_Offset.Value)
    Call WriteReg(RegFolder & "Import\Data\Memory", Memory.Value, REG_DWORD)
    Call WriteReg(RegFolder & "Import\Data\Bytes_Per_Row", Bytes_Per_Row.Value)
    Call WriteReg(RegFolder & "Import\Data\Num_Rows", Num_Rows.Value)
    Call WriteReg(RegFolder & "Import\Data\Split_Into_Columns", Split_Into_Columns.Value, REG_DWORD)
    Call WriteReg(RegFolder & "Import\Data\Format", Format.Value)
End Sub
